#include "gravityModule.h"

//-------------------------------------------------
gravityModule::gravityModule(){
	ofSeedRandom();
}

//-------------------------------------------------	
void gravityModule::setup(){
	reset();
}

//-------------------------------------------------
void gravityModule::reset(){
	
	pct 			= 0;
	framecount 		= 0;
	radius			= 20;
	
	
	int whichSide = rand()%4;
	

	//START POS	
	switch(whichSide){
		case 0:
			startPos.set(160 + rand()%320, radius, 0);
		break;
		
		case 1:
			startPos.set(640-radius, 120 + rand()%240, 0);
		break;
		
		case 2:		
			startPos.set(160 + rand()%320, 480-radius, 0);
		break;
		
		case 3:
			startPos.set(radius, 120 + rand()%240, 0);
		break;
		
		default:
		
		break;
	}
	
	//to make sure the start and endside is never the same
	//we swap the order of the dest switch
			
	//DST POS
	switch(whichSide){
		case 1:
			dst.set(160 + rand()%320, -radius, 0);
		break;
		
		case 3:
			dst.set(640+radius, 120 + rand()%240, 0);
		break;
		
		case 0:		
			dst.set(160 + rand()%320, 480+radius, 0);
		break;
		
		case 2:
			dst.set(-radius, 120 + rand()%240, 0);
		break;
		
		default:
		
		break;
	}
	
	//initial velocity
	vel.set( 0.2 + ( (float)(ofRandomf()*19.0) ), 0.1 + ( (float)(ofRandomf()*22.0) ), 0);
	
	
	pos = startPos;
}

//-------------------------------------------------
void gravityModule::update(){
	
	ofVec3f tmpVel;
	
	tmpVel = dst - pos;
	tmpVel.normalize();
	
	tmpVel *= 0.2;
	
	vel *= 0.955;
	vel += tmpVel;
	
	
	//for all other walls except the dst wall
	//have a collision
	if( abs(  (dst - pos).length() ) >= radius*4 )
	{
	
		if(pos.x+radius > 640){
			pos.x = 640 - radius;
			vel.x *= -1;
		}
		else if(pos.x-radius < 0){
			pos.x = radius;
			vel.x *= -1;
		}
		
		if(pos.y+radius > 480){
			pos.y = 480 - radius;
			vel.y *= -1;
		}
		else if(pos.y-radius < 0){
			pos.y = radius;
			vel.y *= -1;
		}			
	}
	
	
	
	//calulate the angle we are going to our destination
	if( pos.x > 0 && pos.x < 640 && pos.y > 0 && pos.y < 480){
		angle = dst - pos;
	}
	
	
	

	pos += vel;
	
	//If we are close to the destination set pct over 1.0
	//to show we are done
	if( abs(  (dst - pos).length() ) <= 8)pct = 1.1; 
	
	
	if (framecount % 5 == 0) addPoint(pos);
	framecount++;
}

//-------------------------------------------------
void gravityModule::draw(){
	
	ofSetColor(0x00ff00);
	ofCircle(pos.x, pos.y, radius);
}

//-------------------------------------------------
bool gravityModule::bAmIdone(){
	return pct > 1 ? true : false;
}

//-------------------------------------------------
ofVec3f gravityModule::getStartPosition(){
	return startPos;
}

//-------------------------------------------------
float gravityModule::getStartAngle(){

	//this prob isn't right
	//
	
	printf(" angle is %f %f = %f \n", angle.x, angle.y, atan2f(angle.x, angle.y));
	return atan2f(angle.y, angle.x);
}
		
		

